apiVersion: apps/v1
kind: Deployment
metadata:
  name: realworld-api
  labels:
    app.kubernetes.io/name: realworld-api
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version | replace "+" "_" }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/version: {{ .Chart.AppVersion }}
    app.kubernetes.io/component: api
    app.kubernetes.io/part-of: {{ include "realworld.name" . }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
  annotations:
    rollme: {{ randAlphaNum 5 | quote }}
spec:
  replicas: {{ .Values.api.replicaCount }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ include "realworld.name" . }}-api
      app.kubernetes.io/instance: {{ .Release.Name }}
      app.kubernetes.io/version: {{ .Chart.AppVersion }}
      app.kubernetes.io/component: api
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ include "realworld.name" . }}-api
        app.kubernetes.io/instance: {{ .Release.Name }}
        app.kubernetes.io/version: {{ .Chart.AppVersion }}
        app.kubernetes.io/component: api
    spec:
      initContainers:
        - name: {{ .Chart.Name }}-pg-isready
          image: "{{ .Values.db.image.repository }}:{{ .Values.db.image.tag }}"
          imagePullPolicy: IfNotPresent
          command:
            - /bin/sh
            - -ec
            - |
              until (pg_isready -h realworld-db -p 5432 -U $DB_USER); do
                echo waiting for database;
                sleep 2;
              done
          envFrom:
            - secretRef:
                name: db-credentials
      containers:
        - name: {{ .Chart.Name }}-api
          image: "{{ .Values.api.image.repository }}:{{ .Values.api.image.tag }}"
          imagePullPolicy: {{ .Values.api.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.api.containerPort }}
              protocol: TCP
          readinessProbe:
            httpGet:
              path: {{ .Values.api.readinessProbe.path }}
              port: {{ .Values.api.containerPort }}
            initialDelaySeconds: {{ .Values.api.readinessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.api.readinessProbe.periodSeconds }}
            failureThreshold: {{ .Values.api.readinessProbe.failureThreshold }}
          livenessProbe:
            httpGet:
              path: {{ .Values.api.livenessProbe.path }}
              port: {{ .Values.api.containerPort }}
            initialDelaySeconds: {{ .Values.api.livenessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.api.livenessProbe.periodSeconds }}
            failureThreshold: {{ .Values.api.livenessProbe.failureThreshold }}
          resources:
            {{- toYaml .Values.api.resources | nindent 12 }}
          envFrom:
            - configMapRef:
                name: realworld-api-config
            - secretRef:
                name: db-credentials
      imagePullSecrets:
        - name: {{ .Values.imagePullSecret }}
